jQuery( document ).ready( function( $ ) {

/*
 * Add New and Edit pages
 * --------------------------------
*/
	// open or close signature goal settings
	$( 'input#has_signature_goal' ).change( function () {
		if ( $( this ).attr( 'checked' ) ) {
			$( 'div.dk-speakup-signature-goal' ).slideDown();
			$( '#dk-speakup input#signature_goal' ).focus();
		} else {
			$( 'div.dk-speakup-signature-goal' ).slideUp();
		}
	});

	// open or close expiration date settings
	$( 'input#expires' ).change( function () {
		if ( $( this ).attr( 'checked' ) ) {
			$( 'div.dk-speakup-date' ).slideDown();
		} else {
			$( 'div.dk-speakup-date' ).slideUp();
		}
	});

	// open or close address fields settings
	$( 'input#display-address' ).change( function () {
		if ( $( this ).attr( 'checked' ) ) {
			$( 'div.dk-speakup-address' ).slideDown();
			$( '#dk-speakup input#custom-field-label' ).focus();
		} else {
			$( 'div.dk-speakup-address' ).slideUp();
		}
	});

	// open or close custom field settings
	$( 'input#display-custom-field' ).change( function () {
		if ( $( this ).attr( 'checked' ) ) {
			$( 'div.dk-speakup-custom-field' ).slideDown();
			$( '#dk-speakup input#custom-field-label' ).focus();
		} else {
			$( 'div.dk-speakup-custom-field' ).slideUp();
		}
	});

	// open or close email opt-in settings
	$( 'input#display-email-optin' ).change( function () {
		if ( $( this ).attr( 'checked' ) ) {
			$( 'div.dk-speakup-email-optin' ).slideDown();
			$( '#dk-speakup input#email-optin-label' ).focus();
		} else {
			$( 'div.dk-speakup-email-optin' ).slideUp();
		}
	});

	// open or close email header settings
	if ( $( 'input#send_email' ).attr( 'checked' ) ) {
		$( 'div.dk-speakup-email-headers' ).hide();
	}
	$( 'input#send_email' ).change( function () {
		if ( $( this ).attr( 'checked' ) ) {
			$( 'div.dk-speakup-email-headers' ).slideUp();
		} else {
			$( 'div.dk-speakup-email-headers' ).slideDown();
		}
	});

	// auto-focus the title field on add/edit petitions form if empty
	if ( $( '#dk-speakup input#title' ).val() == '' ) {
		$( '#dk-speakup input#title' ).focus();
	}

	// validate form values before submitting
	$( '#dk_speakup_submit' ).click( function() {

		$( '.dk-speakup-error' ).removeClass( 'dk-speakup-error' );

		var errors     = 0;
		var emailRegEx = /^([\w-\.]+@([\w-]+\.)+[\w-]{2,4})?$/;
		var email      = $( '#dk-speakup-edit-petition' ).find( '#petition_email' ).val();
		var subject    = $( '#dk-speakup-edit-petition' ).find( '#petition_subject' ).val();
		var message    = $( '#dk-speakup-edit-petition' ).find( '#petition_message' ).val();
		var goal       = $( '#dk-speakup-edit-petition' ).find( '#signature_goal' ).val();
		var day        = $( '#dk-speakup-edit-petition' ).find( '#day' ).val();
		var year       = $( '#dk-speakup-edit-petition' ).find( '#year' ).val();
		var hour       = $( '#dk-speakup-edit-petition' ).find( '#hour' ).val();
		var minutes    = $( '#dk-speakup-edit-petition' ).find( '#minutes' ).val();

		// if "Do not send email (only collect signatures)" checkbox is not checked
		if ( !$( 'input#send_email' ).attr( 'checked' ) ) {
			// remove any spaces
			var emails = email.split( ',' );
			for ( i=0; i < emails.length; i++ ) {
				if ( emails[i].trim() == '' || !emailRegEx.test( emails[i].trim() ) ) { // must include valid email address
					$( '#dk-speakup-edit-petition' ).find( '#petition_email' ).addClass( 'dk-speakup-error' );
					errors ++;
				}
			}
			
			if ( subject == '' ) { // must include subject
				$( '#dk-speakup-edit-petition' ).find( '#petition_subject' ).addClass( 'dk-speakup-error' );
				errors ++;
			}
		}
		if ( message == '' ) { // must include petition message
			$( '#dk-speakup-edit-petition' ).find( '#petition_message' ).addClass( 'dk-speakup-error' );
			errors ++;
		}

		// if "Set signature goal" checkbox is checked
		if ( $( 'input#has_signature_goal' ).attr( 'checked' ) ) {
			if ( isNaN( goal ) ) { // only numbers are allowed
				$( '#dk-speakup-edit-petition' ).find( '#signature_goal' ).addClass( 'dk-speakup-error' );
				errors ++;
			}
		}

		// if "Set expiration date" checkbox is checked
		if ( $( 'input#expires' ).attr( 'checked' ) ) {
			if ( isNaN( day ) ) { // only numbers are allowed
				$( '#dk-speakup-edit-petition' ).find( '#day' ).addClass( 'dk-speakup-error' );
				errors ++;
			}
			if ( isNaN( year ) ) { // only numbers are allowed
				$( '#dk-speakup-edit-petition' ).find( '#year' ).addClass( 'dk-speakup-error' );
				errors ++;
			}
			if ( isNaN( hour ) ) { // only numbers are allowed
				$( '#dk-speakup-edit-petition' ).find( '#hour' ).addClass( 'dk-speakup-error' );
				errors ++;
			}
			if ( isNaN( minutes ) ) { // only numbers are allowed
				$( '#dk-speakup-edit-petition' ).find( '#minutes' ).addClass( 'dk-speakup-error' );
				errors ++;
			}
		}

		// if no errors found, submit the data via ajax
		if ( errors == 0 ) {
			$( 'form#dk-speakup-edit-petition' ).submit();
		}
		else {
			$( '.dk-speakup-error-msg' ).fadeIn();
		}

		return false;

	});

	// display character count for for Twitter Message field
	// max characters is 120 to accomodate the shortnened URL provided by Twitter when submitted
	if ( $( '#twitter_message' ).length > 0 ) {
	  twitterCount();
	}
	$( '#twitter_message' ).keyup( function() {
		twitterCount();
	});
	function twitterCount() {
		var max_characters = 120;
		var text = $( '#twitter_message' ).val();
		var charcter_count = text.length;
		var charcters_left = max_characters - charcter_count;

		if ( charcter_count <= max_characters ) {
			$( '#twitter-counter' ).html( charcters_left ).css( 'color', '#000' );
		}
		else {
			$( '#twitter-counter' ).html( charcters_left ).css( 'color', '#c00' );
		}
	}

/*
 * table view pages
 * --------------------------------
*/
	// when new page number is entered using the form on paginated admin pages,
	// construct a new url string to pass along the variables needed to update page
	// and redirect to the new url
	$( '#dk-speakup-pager' ).submit( function() {
		var page        = $( '#dk-speakup-page' ).val();
		var paged       = $( '#dk-speakup-paged' ).val();
		var total_pages = $( '#dk-speakup-total-pages' ).val();
		var baseurl     = String( document.location ).split( '?' );
		var newurl      = baseurl[0] + '?page=' + page + '&paged=' + paged + '&total_pages=' + total_pages;
		document.location = newurl;
		return false;
	});

	// display confirmation box when user tries to delete a petition
	// warns that all signatures associated with the petition will also be deleted
	$( '.dk-speakup-delete-petition' ).click( function( e ) {
		// stop link from firing
		e.preventDefault();
		// grab the href
		var delete_link = $( this ).attr( 'href' );
		// confirmation message is contained in a hidden div in the HTML
		// so that it is accessible to PHP translation methods
		var confirm_message = $( '#dk-speakup-delete-confirmation' ).html();
		// add new line characters for nicer confirm msg display
		confirm_message = confirm_message.replace( '? ', '?\n\n' )
		// display confirm box
		var confirm_delete = confirm( confirm_message );
		// if user presses OK, process delete link
		if ( confirm_delete == true ) {
			document.location = delete_link;
		}
	});

	// highlight hovered row on signatures table
	// should help people avoid deleting the wrong signature
	$( 'tr.dk-speakup-signatures-row' ).hover(
		function() {
			$( this ).addClass( 'dk-speakup-row-hover' );
		},
		function() {
			$( this ).removeClass( 'dk-speakup-row-hover' );
		}
	);

	// Select box navigation on Signatures page
	// to switch between different petitions
	$('#dk-speakup-switch-petition').change( function() {
		var page    = 'dk_speakup_signatures';
		var action  = 'petition';
		var pid     = $('#dk-speakup-switch-petition option:selected').val();
		var baseurl = String( document.location ).split( '?' );
		var newurl  = baseurl[0] + '?page=' + page + '&action=' + action + '&pid=' + pid;
		document.location = newurl;
	});

	// display confirmation box when user tries to re-send confirmation emails
	// warns that a bunch of emails will be sent out if they hit OK
	$( 'a#dk-speakup-reconfirm' ).click( function( e ) {
		// stop link from firing
		e.preventDefault();
		// grab the href
		var link = $( this ).attr( 'href' );
		// confirmation message is contained in a hidden div in the HTML
		// so that it is accessible to PHP translation methods
		var confirm_message = $( '#dk-speakup-reconfirm-confirmation' ).html();
		// add new line characters for nicer confirm msg display
		confirm_message = confirm_message.replace( '? ', '?\n\n' )
		// display confirm box
		var confirm_delete = confirm( confirm_message );
		// if user presses OK, process delete link
		if ( confirm_delete == true ) {
			document.location = link;
		}
	});

});