jQuery( document ).ready( function( $ ) {

	$( '.dk-speakup-submit' ).click( function() {
		var petition  = '#' + $( this ).attr( 'name' );
		var id        = $( petition ).find( '.dk-speakup-id' ).val();
		var permalink = $( petition ).find( '.dk-speakup-permalink' ).val();
		var posttitle = $( petition ).find( '.dk-speakup-posttitle' ).val();
		var firstname = $( petition ).find( '.dk-speakup-first-name' ).val();
		var lastname  = $( petition ).find( '.dk-speakup-last-name' ).val();
		var email     = $( petition ).find( '.dk-speakup-email' ).val();
		var street    = $( petition ).find( '.dk-speakup-street' ).val();
		var city      = $( petition ).find( '.dk-speakup-city' ).val();
		var state     = $( petition ).find( '.dk-speakup-state' ).val();
		var postcode  = $( petition ).find( '.dk-speakup-postcode' ).val();
		var country   = $( petition ).find( '.dk-speakup-country' ).val();
		var custom    = $( petition ).find( '.dk-speakup-custom-field' ).val();
		var optin     = '';
		var twitter   = $( petition ).find( '.dk-speakup-twitter-message' ).val();
		if ( $( petition ).find( '.dk-speakup-optin' ).attr( 'checked' ) ) {
			optin = 'on';
		}

		// make sure error notices are turned off before checking for new errors
		$( petition ).find( 'input' ).removeClass( 'dk-speakup-error' );

		// validate form values
		var errors = 0;
		var emailRegEx = /^([\w-\.]+@([\w-]+\.)+[\w-]{2,4})?$/;
		if ( email == '' || !emailRegEx.test( email ) ) {
			$( petition ).find( '.dk-speakup-email' ).addClass( 'dk-speakup-error' );
			errors ++;
		}
		if ( firstname == '' ) {
			$( petition ).find( '.dk-speakup-first-name' ).addClass( 'dk-speakup-error' );
			errors ++;
		}
		if ( lastname == '' ) {
			$( petition ).find( '.dk-speakup-last-name' ).addClass( 'dk-speakup-error' );
			errors ++;
		}

		// if no errors found, submit the data via ajax
		if ( errors == 0 ) {
			var data = {
				action:       'dk_speakup_sendmail',
				id:           id,
				first_name:   firstname,
				last_name:    lastname,
				email:        email,
				street:       street,
				city:         city,
				state:        state,
				postcode:     postcode,
				country:      country,
				custom_field: custom,
				optin:        optin
			};

			// submit form data and handle ajax response
			$.post( dk_speakup_js.ajaxurl, data,
				function( response ) {
					$( petition ).find( '.dk-speakup-petition' ).hide();
					$( petition ).find( '.dk-speakup-response' ).fadeIn().html( response );
					$( petition ).find( '.dk-speakup-share' ).fadeIn();

					// launch Facebook sharing window
					$( '.dk-speakup-facebook' ).click( function() {
						var url = 'http://www.facebook.com/sharer.php?u=' + permalink + '&amp;t=' + posttitle;
						window.open( url, 'facebook', 'height=420,width=550,left=100,top=100,resizable=yes,location=no,status=no,toolbar=no' );
					});
					// launch Twitter sharing window
					$( '.dk-speakup-twitter' ).click( function() {
						var url = 'http://twitter.com/share?url=' + permalink + '&text=' + twitter;
						window.open( url, 'twitter', 'height=420,width=550,left=100,top=100,resizable=yes,location=no,status=no,toolbar=no' );
					});
				}
			);
		}

		return false;
	});

	// hide or show form labels depending on input fields
	$( '.dk-speakup-petition-wrap input[type=text]' ).focus( function( e ) {
		var label = $( this ).siblings( 'label' );
		if ( $( this ).val() == '' ) {
			$( this ).siblings( 'label' ).addClass( 'dk-speakup-focus' ).removeClass( 'dk-speakup-blur' );
		}
		$( this ).blur( function(){
			if ( this.value === '' ) {
				label.addClass( 'dk-speakup-blur' ).removeClass( 'dk-speakup-focus' );
			}
		}).focus( function() {
			label.addClass( 'dk-speakup-focus' ).removeClass( 'dk-speakup-blur' );
		}).keydown( function( e ) {
			label.addClass( 'dk-speakup-focus' ).removeClass( 'dk-speakup-blur' );
			$( this ).unbind( e );
		});
	});

	// hide labels on filled input fields when page is reloaded
	$( '.dk-speakup-petition-wrap input[type=text]' ).each( function() {
		if ( $( this ).val() != '' ) {
			$( this ).siblings( 'label' ).addClass( 'dk-speakup-focus' );
		}
	});

});