<?php
/*
Plugin Name: SpeakUp! Email Petitions
Plugin URI: http://speakup.designkode.com/
Description: Create custom email petition forms and include them on your site via shortcode or widget. Signatures are saved in the database and can be exported to CSV.
Version: 1.7.2
Author: Kreg Wallace
Author URI: http://speakup.designkode.com/kreg-wallace
License: GPL2
*/

global $wpdb, $db_petitions, $db_signatures, $dk_speakup_version;
$db_petitions = $wpdb->prefix . 'dk_speakup_petitions';
$db_signatures = $wpdb->prefix . 'dk_speakup_signatures';
$dk_speakup_version = '1.7.2';

$wp_version = get_bloginfo( 'version' );

// enable translations
add_action( 'init', 'dk_speakup_translate' );
function dk_speakup_translate() {
	load_plugin_textdomain( 'dk_speakup', false, 'speakup-email-petitions/languages' );
}

// load admin functions only on admin pages
if ( is_admin() ) {
	// load plugin update / installation routines
	include_once( dirname( __FILE__ ) . '/includes/install.php' );
	// load plugin setup functions
	include_once( dirname( __FILE__ ) . '/includes/admin.php' );
	// load petitions page
	include_once( dirname( __FILE__ ) . '/includes/admin-petitions.php' );
	// load edit petitions page
	include_once( dirname( __FILE__ ) . '/includes/admin-edit.php' );
	// load signatures page
	include_once( dirname( __FILE__ ) . '/includes/admin-signatures.php' );
	// load plugin settings page
	include_once( dirname( __FILE__ ) . '/includes/admin-settings.php' );
	// load the admin utility functions
	include_once( dirname( __FILE__ ) . '/includes/admin-utils.php' );
	
	// load contextual help for newer WordPress installs (requires 3.3.1)
	if( $wp_version > '3.3' ) {
		include_once( dirname( __FILE__ ) . '/includes/help.php' );
	}

	// enable plugin activation function
	register_activation_hook( __FILE__, 'dk_speakup_install' );
}
else {
	// load functions for controlling the publicly viewable petition form
	include_once( dirname( __FILE__ ) . '/includes/public.php' );
	// load the public utility functions
	include_once( dirname( __FILE__ ) . '/includes/public-utils.php' );
}

// load the widget
include_once( dirname( __FILE__ ) . '/includes/widget.php' );

// add Support and Donate meta links to the Plugins page
add_filter( 'plugin_row_meta', 'dk_speakup_meta_links', 10, 2 );
function dk_speakup_meta_links( $links, $file ) {
	$plugin = plugin_basename( __FILE__ );

	// create link
	if ( $file == $plugin ) {
		return array_merge(
			$links,
			array(
				sprintf( '<a href="http://wordpress.org/tags/speakup-email-petitions?forum_id=10">%s</a>', __( 'Support', 'dk_speakup' ) ),
				sprintf( '<a href="https://www.paypal.com/cgi-bin/webscr?cmd=_s-xclick&hosted_button_id=ADP2TPGYEU5NU">%s</a>', __( 'Donate', 'dk_speakup' ) )
			)
		);
	}

	return $links;
}

?>