<?php

// if uninstall is not initiated by WordPress, do nothing
if( !defined( 'WP_UNINSTALL_PLUGIN' ) ) exit ();

// otherwise...

// delete options from options table
delete_option( 'dk_speakup_options' );
delete_option( 'dk_speakup_version' );

// set variables for accessing database
global $wpdb;
$db_petitions = $wpdb->prefix . "dk_speakup_petitions";
$db_signatures = $wpdb->prefix . "dk_speakup_signatures";
$db_options = $wpdb->prefix . "options";

// delete any remaining transients

// get ids for all existing petitions
$sql_petition_ids = "SELECT id FROM $db_petitions";
$petitions = $wpdb->get_results( $sql_petition_ids );

// loop through petitions and delete associated transients
foreach ( $petitions as $petition ) {
	// construct transient names
	$transient_petition = 'dk_speakup_petition_' . $petition->id;
	$transient_signatureslist = 'dk_speakup_signatureslist_' . $petition->id;
	$transient_signatures_total = 'dk_speakup_signatures_total_' . $petition->id;

	// delete transients
	delete_transient( $transient_petition );
	delete_transient( $transient_signatureslist );
	delete_transient( $transient_signatures_total );
}

// delete widget data
$sql_widget = "DELETE FROM $db_options WHERE option_name = 'widget_dk_speakup_petition_widget'";
$wpdb->query( $sql_widget );

// delete custom database tables
$sql_petitions_table = "DROP TABLE $db_petitions";
$wpdb->query( $sql_petitions_table );

$sql_signatures_table = "DROP TABLE $db_signatures";
$wpdb->query( $sql_signatures_table );

?>